<?php
require('fpdf.php');

class PDF_MySQL_Table extends FPDF
{
var $ProcessingTable=false;
var $aCols=array();
var $TableX;
var $HeaderColor;
var $RowColors;
var $ColorIndex;

function Header()
{
	//Print the table header if necessary
	if($this->ProcessingTable)
		$this->TableHeader();
}

function TableHeader()
{
    $this->SetXY(10,70);
	$this->SetFont('Arial','B',10);
	//$this->SetX($this->TableX);
	$fill=!empty($this->HeaderColor);
	if($fill)
		$this->SetFillColor($this->HeaderColor[0],$this->HeaderColor[1],$this->HeaderColor[2]);
	foreach($this->aCols as $col)
		$this->Cell($col['w'],6,$col['c'],1,0,$col['a'],$fill);
	$this->Ln();
}

function Row($data)
{

    //Calculate the height of the row
    $nb=0;
    for($i=0;$i<count($data);$i++){
	if($i==0){
	$w = 7;
	}
	if($i==1){
	$w = 25;
	}
	if($i==2){
	$w = 52;
	}
	if($i==3){
	$w = 15;
	}
	if($i==4){
	$w = 15;
	}
	if($i==5){
	$w = 20;
	}
	if($i==6){
	$w = 20;
	}
	if($i==7){
	$w = 20;
	}
	if($i==8){
	$w = 20;
	}
	
	
    $nb=max($nb,$this->NbLines($w,$data[$i]));
			}
    $h=5;
    
    //Issue a page break first if needed
    $this->CheckPageBreak(45);
    //Draw the cells of the row
    for($i=0;$i<count($data);$i++)
    {

    $a=isset($this->aligns[$i]) ? $this->aligns[$i] : 'L';
	if($i==0){
    	$w = 8;
    	$a ="C";
	}
	if($i==1){
	    $w = 82;

	}
	if($i==2){
    	$w = 40;
    	$a ="C";
	}
	if($i==3){
    	$w = 30;
    	$a ="C";
	}
	if($i==4){
    	$w = 30;
    	$a ="R";
	}
	if($i==5){
	    $w = 80;
	}


    if($i==0){
	    $lenthofdesciption = strlen($data[1]);// $k is number of row of data from sql
    
        if($lenthofdesciption>70){  //If character length > 35, then go next row 
            $h+=10;
        }elseif($lenthofdesciption>34){  //If character length > 35, then go next row 
            $h+=5;
        }
	}
	
  //$w=$this->widths[$i];
      
        //Save the current position
        $x=$this->GetX();
        $y=$this->GetY();
        /*if($i==0){
            $this->SetX(7);
        }else{
            $this->SetX($x-3);
        }*/
        //Draw the border
        //$this->Rect($x-3,$y,$w,$h);
        //Print the text
		$this->SetFont('Arial','',10);
		$this->MultiCell($w,5,$data[$i],0,$a);
        //Put the position to the right of the cell
        $this->SetXY($x+$w,$y);
    }
    //Go to the next line
    $this->Ln($h);
}


function Rowall($data)
{

    //Calculate the height of the row
    $nb=0;
    for($i=0;$i<count($data);$i++){
	if($i==0){
	$w = 10;
	}
	if($i==1){
	$w = 25;
	}
	if($i==2){
	$w = 52;
	}
	if($i==3){
	$w = 15;
	}
	if($i==4){
	$w = 15;
	}
	if($i==5){
	$w = 20;
	}
	if($i==6){
	$w = 20;
	}
	if($i==7){
	$w = 20;
	}
	if($i==8){
	$w = 20;
	}
	
    $nb=max($nb,$this->NbLines($w,$data[$i]));
			}
    $h=5;

    //Issue a page break first if needed
    $this->CheckPageBreak($h);
    //Draw the cells of the row
    for($i=0;$i<count($data);$i++)
    {

    $a=isset($this->aligns[$i]) ? $this->aligns[$i] : 'L';
	if($i==0){
    	$w = 8;
    	$a ="C";
	}
	if($i==1){
	    $w = 82;

	}
	if($i==2){
    	$w = 40;
    	$a ="C";
	}
	if($i==3){
    	$w = 30;
    	$a ="C";
	}
	if($i==4){
    	$w = 30;
    	$a ="C";
	}
	if($i==5){
	    $w = 80;
	}

	
	
	
  //$w=$this->widths[$i];
      
        //Save the current position
        $x=$this->GetX();
        $y=$this->GetY();
        //Draw the border
       // $this->Rect($x,$y,$w,$h);
        //Print the text
		$this->SetFont('Arial','',9);
		if($data[0]==16){
            $this->MultiCell($w,$h,'',LRB,$a);
		}else{
		    $this->MultiCell($w,$h,'',LR,$a);
		}
        //Put the position to the right of the cell
        $this->SetXY($x+$w,$y);
    }
    //Go to the next line
    $this->Ln($h);
}

function Rowboldtest($data)
{

    //Calculate the height of the row
    $nb=0;
    for($i=0;$i<count($data);$i++){
	if($i==0){
	$w = 177;
	}
	if($i==1){
	$w = 20;
	}
	
    $nb=max($nb,$this->NbLines($w,$data[$i]));
			}
    $h=5*1;

    //Issue a page break first if needed
    $this->CheckPageBreak($h);
    //Draw the cells of the row
    for($i=0;$i<count($data);$i++)
    {

    $a=isset($this->aligns[$i]) ? $this->aligns[$i] : 'L';
	if($i==0){
	$w = 21;
	$a ="L";
	}
	if($i==1){
	$w = 30;
	$a ="C";
	}
    if($i==2){
	$w = 30;
	$a ="R";
	}
	
  //$w=$this->widths[$i];
      
        //Save the current position
        $x=$this->GetX();
        $y=$this->GetY();
        
        //Draw the border
		if($i==1){
        //$this->Rect($x,$y,$w,$h);
		}
        //Print the text
		$this->SetFont('Arial','B',10);
        $this->MultiCell($w,5,$data[$i],0,$a);
        //Put the position to the right of the cell
        $this->SetXY($x+$w,$y);
    }
    //Go to the next line
    $this->Ln($h);
}

function Rowboldtest2($data)
{

    //Calculate the height of the row
    $nb=0;
    for($i=0;$i<count($data);$i++){
	if($i==0){
	$w = 177;
	}
	if($i==1){
	$w = 20;
	}
	
    $nb=max($nb,$this->NbLines($w,$data[$i]));
			}
    $h=5*1;

    //Issue a page break first if needed
    $this->CheckPageBreak($h);
    //Draw the cells of the row
    for($i=0;$i<count($data);$i++)
    {

    $a=isset($this->aligns[$i]) ? $this->aligns[$i] : 'L';
	if($i==0){
	$w = 26;
	$a ="L";
	}
	if($i==1){
	$w = 60;
	$a ="L";
	}

	
  //$w=$this->widths[$i];
      
        //Save the current position
        $x=$this->GetX();
        $y=$this->GetY();
        
        //Draw the border
		if($i==1){
        //$this->Rect($x,$y,$w,$h);
		}
        //Print the text
		$this->SetFont('Arial','B',8.5);
        $this->MultiCell($w,5,$data[$i],0,$a);
        //Put the position to the right of the cell
        $this->SetXY($x+$w,$y);
    }
    //Go to the next line
    $this->Ln($h);
}

function Rowboldtest3($data)
{

    //Calculate the height of the row
    $nb=0;
    for($i=0;$i<count($data);$i++){
	if($i==0){
	$w = 177;
	}
	if($i==1){
	$w = 20;
	}
	
    $nb=max($nb,$this->NbLines($w,$data[$i]));
			}
    $h=5*1;

    //Issue a page break first if needed
    $this->CheckPageBreak($h);
    //Draw the cells of the row
    for($i=0;$i<count($data);$i++)
    {

    $a=isset($this->aligns[$i]) ? $this->aligns[$i] : 'L';
	if($i==0){
	$w = 32;
	$a ="R";
	}
	if($i==1){
	$w = 25;
	$a ="R";
	}

	
  //$w=$this->widths[$i];
      
        //Save the current position
        $x=$this->GetX();
        $y=$this->GetY();
        
        //Draw the border
		if($i==1){
        //$this->Rect($x,$y,$w,$h);
		}
        //Print the text
        $this->SetFont('Arial','B',10);
        $this->MultiCell($w,5,$data[$i],1,$a);
        //Put the position to the right of the cell
        $this->SetXY($x+$w,$y);
    }
    //Go to the next line
    $this->Ln($h);
}

function Rowall2($data)
{

    //Calculate the height of the row
    $nb=0;
    for($i=0;$i<count($data);$i++){
	if($i==0){
	$w = 10;
	}
	if($i==1){
	$w = 25;
	}
	if($i==2){
	$w = 52;
	}
	if($i==3){
	$w = 15;
	}
	if($i==4){
	$w = 15;
	}
	if($i==5){
	$w = 20;
	}
	if($i==6){
	$w = 20;
	}
	if($i==7){
	$w = 20;
	}
	if($i==8){
	$w = 20;
	}
	
    $nb=max($nb,$this->NbLines($w,$data[$i]));
			}
    $h=5*2;

    //Issue a page break first if needed
    $this->CheckPageBreak($h);
    //Draw the cells of the row
    for($i=0;$i<count($data);$i++)
    {

    $a=isset($this->aligns[$i]) ? $this->aligns[$i] : 'L';
	if($i==0){
	$w = 10;
	}
	if($i==1){
	$w = 20;
		$a ="C";
	}
	if($i==2){
	$w = 60;
	}

	if($i==3){
	$w = 57;
	}
	
	if($i==4){
	$w = 20;
	$a ="R";
	}
	if($i==5){
	$w = 23;
		$a ="R";
	}
	
  //$w=$this->widths[$i];
      
        //Save the current position
        $x=$this->GetX();
        $y=$this->GetY();
        //Draw the border
       // $this->Rect($x,$y,$w,$h);
        //Print the text
		$this->SetFont('Arial','',9);
		if($i==6){
        //$this->MultiCell($w,$h,$data[$i],RB,$a);
		}else{
		  $this->MultiCell($w,$h,$data[$i],LRB,$a);
		}
        //Put the position to the right of the cell
        $this->SetXY($x+$w,$y);
    }
    //Go to the next line
    $this->Ln($h);
}
function CheckPageBreak($h)
{
    //If the height h would cause an overflow, add a new page immediately
    if($this->GetY()+$h>$this->PageBreakTrigger)
        $this->AddPage($this->CurOrientation);
}
function NbLines($w,$txt)
{
    //Computes the number of lines a MultiCell of width w will take
    $cw=&$this->CurrentFont['cw'];
    if($w==0)
        $w=$this->w-$this->rMargin-$this->x;
    $wmax=($w-2*$this->cMargin)*1000/$this->FontSize;
    $s=str_replace("\r",'',$txt);
    $nb=strlen($s);
    if($nb>0 and $s[$nb-1]=="\n")
        $nb--;
    $sep=-1;
    $i=0;
    $j=0;
    $l=0;
    $nl=1;
    while($i<$nb)
    {
        $c=$s[$i];
        if($c=="\n")
        {
            $i++;
            $sep=-1;
            $j=$i;
            $l=0;
            $nl++;
            continue;
        }
        if($c==' ')
            $sep=$i;
        $l+=$cw[$c];
        if($l>$wmax)
        {
            if($sep==-1)
            {
                if($i==$j)
                    $i++;
            }
            else
                $i=$sep+1;
            $sep=-1;
            $j=$i;
            $l=0;
            $nl++;
        }
        else
            $i++;
    }
    return $nl;
}

function CalcWidths($width,$align)
{
	//Compute the widths of the columns
	$TableWidth=0;
	foreach($this->aCols as $i=>$col)
	{
		$w=$col['w'];
		if($w==-1)
			$w=$width/count($this->aCols);
		elseif(substr($w,-1)=='%')
			$w=$w/100*$width;
		$this->aCols[$i]['w']=$w;
		$TableWidth+=$w;
	}
	//Compute the abscissa of the table
	if($align=='C')
		$this->TableX=max(($this->w-$TableWidth)/2,0);
	elseif($align=='R')
		$this->TableX=max($this->w-$this->rMargin-$TableWidth,0);
	else
		$this->TableX=$this->lMargin;
}

function AddCol($field=-1,$width=-1,$caption='',$align)
{
	//Add a column to the table
	if($field==-1)
		$field=count($this->aCols);
	$this->aCols[]=array('f'=>$field,'c'=>$caption,'w'=>$width,'a'=>$align);
}

function Table($query,$prop=array(),$id)
{
$sql1= "SELECT * FROM debtor_invoice where id='$id'";
$result = mysql_query($sql1);
$cv= mysql_fetch_array($result);
	//Issue query
	$res=mysql_query($query) or die('Error: '.mysql_error()."<BR>Query: $query");
	//Add all columns if none was specified
	if(count($this->aCols)==0)
	{
		$nb=mysql_num_fields($res);
		for($i=0;$i<$nb;$i++)
			$this->AddCol();
	}
	//Retrieve column names when not specified
	foreach($this->aCols as $i=>$col)
	{
		if($col['c']=='')
		{
			if(is_string($col['f']))
				$this->aCols[$i]['c']=ucfirst($col['f']);
			else
				$this->aCols[$i]['c']=ucfirst(mysql_field_name($res,$col['f']));
		}
	}
	//Handle properties
	if(!isset($prop['width']))
		$prop['width']=0;
	if($prop['width']==0)
		$prop['width']=$this->w-$this->lMargin-$this->rMargin;
	if(!isset($prop['align']))
		$prop['align']='C';
	if(!isset($prop['padding']))
		$prop['padding']=$this->cMargin;
	$cMargin=$this->cMargin;
	$this->cMargin=$prop['padding'];
	if(!isset($prop['HeaderColor']))
		$prop['HeaderColor']=array();
	$this->HeaderColor=$prop['HeaderColor'];
	if(!isset($prop['color1']))
		$prop['color1']=array();
	if(!isset($prop['color2']))
		$prop['color2']=array();
	$this->RowColors=array($prop['color1'],$prop['color2']);
	//Compute column widths
	$this->CalcWidths($prop['width'],$prop['align']);
	//Print header
	$this->TableHeader();
	//Print rows
	$this->SetFont('Arial','',11);
	$this->ColorIndex=0;
	$this->ProcessingTable=true;
	$a=1;
	$dataprint = array();
	$dataprint2 = array();
	//$this->SetX($this->TableX);
	$totalctn =0;
	while($row=mysql_fetch_array($res)){
        $sql1= "SELECT * FROM laf where id='".$id."'";
        $csgn = mysql_fetch_array(mysql_query($sql1));
        
       $sql1= "SELECT * FROM laf_dtl where item='".$row[grade]."' and lpn='".$row[batch]."' and qty='".$row[itemno]."' and safid='".$id."' ";
       
        $dblafdtl = mysql_fetch_array(mysql_query($sql1));
        echo $sql2;
        $subamount = number_format($row[ldshipped]*$row[unitprice],2,'.','');
        $taxamount = ($subamount*$row['taxpercent'])/100;
        $tsubamount += $subamount;
        $ttaxamount += $taxamount;
        $twsubamount += $subamount;
        $uom ="EA";
        //$ncmr = "-";
    
		$dataprint[0] = $a;
		$dataprint[1] = $row[invdesc];
		$dataprint[2] = str_replace(" ",'',$row[trafficcode]);
		$dataprint[3] = $row[ldshipped];
		$dataprint[4] = number_format($subamount,2,'.',',');
		$dataprint[5] = '';
		//$dataprint[6] = $row[shipped];
		//$dataprint[7] = "1 X $row[itemno]";
		
		//$dataprint[8] = $dblafdtl[plt];
	
		
		//$dataprint[8] =  number_format($row[unitprice],2,'.',',');
	
		//$subamount = $row['pricemyr'];
		//$taxamount = ($subamount*$row['taxpercent'])/100;

		//$dataprint[9] = number_format($row[pricemyr],2,'.',',');
		
		$this->Row($dataprint);
		$a+=1;
		
		$toexl += number_format($subamount,2,'.','');
		$togst += number_format($taxamount,2,'.','');
		$tpcs += $row[ldshipped];
		$tctn += $row[qty_in];
		$totalctn+=1;
		
	}
	
	for($k=$a;$k<13;$k++){

	$dataprint3[0] = "";
		$dataprint3[1] = "";
		$dataprint3[2] = "";
		$dataprint3[3] = "";
		$dataprint3[4] = "";
		$dataprint3[5] = "";
		$dataprint3[6] = "";
	//$this->Rowall($dataprint3);
	}
	//$this->Rowall2($dataprint3);
	/*$x=$this->GetX();
    $y=$this->GetY();
    
    $this->SetX(7);
    for($z=$a; $z<=20;$z++){
        $dataprint3[0] = $z;
        $dataprint3[1] = "";
		$dataprint3[2] = "";
		$dataprint3[3] = "";
		$dataprint3[4] = "";
		$this->SetX(7);
        $this->Rowall($dataprint3);
    }*/

	
$sql1= "SELECT * FROM laf where id='$id'";
$result = mysql_query($sql1);
$cv= mysql_fetch_array($result);	
$nettotal=number_format($tsubamount+$ttaxamount,2,'.','');
	$rndvalue = round($nettotal / 0.05) *0.05;
$length=number_format($csgn[length]);
$width=number_format($csgn[width]);
$height=number_format($csgn[height]);
$int = $rndvalue-$nettotal;
        $x=85;
        $y=65;
        
		//$dataprint2[0] = "Rounding Adj (RM):";
		//$dataprint2[1] = number_format($int,2,'.',',');
	    //$this->Rowboldtest($dataprint2);
        
        $this->Line(100, 146, 200, 146);
        
        $this->SetXY($x,$y+81);
        $dataprint2[0] = "";
        $dataprint2[1] = "JUMLAH";
        $dataprint2[2] = "";
        $this->Rowboldtest($dataprint2);
        
        $this->SetXY($x+34,$y+81);
        $dataprint2[0] = "";
        $dataprint2[1] = "$tpcs";
        $dataprint2[2] = "";
        $this->Rowboldtest($dataprint2);
        
        $this->SetXY($x+34,$y+81);
        $dataprint2[0] = "";
        $dataprint2[1] = "";
        $dataprint2[2] = number_format($toexl,2,'.',',');
        $this->Rowboldtest($dataprint2);

        /*
        $this->SetXY($x+51,$y+5);
        $dataprint2[0] = "Dimension :";
        $dataprint2[1] = "$length X $width X $height CM X $csgn[plts] PLTS";
        $this->Rowboldtest2($dataprint2);
        
        $this->SetXY($x+51,$y+10);
        $dataprint2[0] = "Freight Term :";
        $dataprint2[1] = "$csgn[freight_term]";
        $this->Rowboldtest2($dataprint2);
        
        $this->SetXY($x+51,$y+15);
        $dataprint2[0] = "Mode of Trans. :";
        $dataprint2[1] = "$csgn[transport_mode]";
        $this->Rowboldtest2($dataprint2);
        
        $this->SetXY($x+51,$y+20);
        $dataprint2[0] = "Freight Carrier :";
        $dataprint2[1] = "$csgn[freight_carrier]";
        $this->Rowboldtest2($dataprint2);
        */
       /* $this->SetXY($x+137,$y+5);
        $dataprint2[0] = "Sub Total :";
        $dataprint2[1] = number_format($toexl,2,'.',',');
        $this->Rowboldtest3($dataprint2);
        
        $this->SetXY($x+137,$y+10);
        $dataprint2[0] = "Tax :";
        $dataprint2[1] = "";
        $this->Rowboldtest3($dataprint2);
        
        $this->SetXY($x+137,$y+15);
        $dataprint2[0] = "Ship. Handling :";
        $dataprint2[1] = "";
        $this->Rowboldtest3($dataprint2);
        
        $this->SetXY($x+137,$y+20);
        $dataprint2[0] = "Total (MYR) :";
        $dataprint2[1] = $toexl;
        $this->Rowboldtest3($dataprint2);
        
        */
       
$dataprint2[0] = "Sub Total:";
		$dataprint2[1] = number_format($nettotal,2,'.',',');
	//$this->Rowboldtest($dataprint2);
$dataprint2[0] = "Discount $cv[doremark1] %:";
$va  = ($nettotal/100)*$cv[doremark1];
		$dataprint2[1] = number_format($va,2,'.',',');
	//$this->Rowboldtest($dataprint2);
//	$dataprint2[0] = "Total Price:";
//		$dataprint2[1] = number_format($nettotal-$va,2,'.',',');
//	$this->Rowboldtest($dataprint2);
	//$row2=mysql_fetch_array(mysql_query('select code,name,terms from creditor order by code'));
	//$row2 = array("code"=>"35","name"=>"37","terms"=>"43");
	//$this->Row($row2);
$this->ProcessingTable=false;
	$this->cMargin=$cMargin;
	$this->aCols=array();
}
}
?>
